# $Id: e-smith-lib-compspec.spec,v 1.4 2022/04/06 20:22:27 jpp Exp $

Summary: bash completion specifications for smeserver-lib utilities
%define name smeserver-lib-compspec
Name: %{name}
%define version 11.0.0
%define release 2
Version: %{version}
Release: %{release}%{?dist}
License: GPL
Group: Networking/Daemons
Source: %{name}-%{version}.tar.xz

BuildRoot: /var/tmp/e-smith-buildroot
BuildArchitectures: noarch
Requires: smeserver-lib
BuildRequires: smeserver-devtools 
AutoReqProv: no

Provides: e-smith-lib-compspec
%description
smeserver module containing bash completion specifications for the
e-smith-lib command-line utilities (db, config, expand-template, signal-event).

%prep
%setup
mkdir -p  root/etc/e-smith/events/%{name}-update

%build


%install
rm -rf $RPM_BUILD_ROOT
(cd root   ; find . -depth -print | cpio -dump $RPM_BUILD_ROOT)
rm -f %{name}-%{version}-filelist
/sbin/e-smith/genfilelist $RPM_BUILD_ROOT |
grep -v test.pl > %{name}-%{version}-filelist

%clean 
rm -rf $RPM_BUILD_ROOT

%files -f %{name}-%{version}-filelist
%defattr(-,root,root)

%changelog
* Sat Mar 23 2024 Brian Read <brianr@koozali.org>11.0.0-2.sme
- Change Requires: e-smith- to Requires:smeserver-

* Sat Mar 23 2024 Brian Read <brianr@koozali.org>11.0.0-1.sme
- Update Release and Version to base version and 1st release for SME11 [SME: 12518]

* Mon Mar 11 2024 rename-e-smith-pkg.sh by Trevor Batley <trevor@batley.id.au> 2.6.0-6.sme
- Rename to smeserver-lib-compspec [SME: 12359]

* Wed Jul 12 2023 cvs2git.sh aka Brian Read <brianr@koozali.org> 2.6.0-5.sme
- Roll up patches and move to git repo [SME: 12338]

* Wed Jul 12 2023 BogusDateBot
- Eliminated rpmbuild "bogus date" warnings due to inconsistent weekday,
  by assuming the date is correct and changing the weekday.

* Wed Apr 06 2022 Jean-Philippe Pialasse <tests@pialasse.com> 2.6.0-4.sme
- fix last dot erased on completion  [SME: 11368]
- error on incorect cmd input [SME: 4661]

* Sat Feb 20 2021 Jean-Philipe Pialasse <tests@pialasse.com> 2.6.0-3.sme
- allow easy access to templates.metadata to expand desired files [SME: 11312]

* Wed Jan 06 2021 Jean-Philipe Pialasse <tests@pialasse.com> 2.6.0-2.sme
- add update event [SME: 11142]

* Fri Feb 05 2016 stephane de Labrusse <stephdl@de-labrusse.fr> 2.6.0-1.sme
- Initial release to sme10

* Fri Jan 25 2013 Shad L. Lords <slords@mail.com> 2.4.0-1.sme
- Roll new stream for sme9

* Tue Oct 7 2008 Shad L. Lords <slords@mail.com> 2.2.0-1.sme
- Roll new stream to separate sme7/sme8 trees [SME: 4633]

* Sun Apr 29 2007 Shad L. Lords <slords@mail.com>
- Clean up spec so package can be built by koji/plague

* Thu Dec 07 2006 Shad L. Lords <slords@mail.com>
- Update to new release naming.  No functional changes.
- Make Packager generic

* Thu Mar 16 2006 Gordon Rowell <gordonr@gormand.com.au> 1.2.0-01
- Roll stable stream version. [SME: 1016]

* Wed Nov 30 2005 Gordon Rowell <gordonr@gormand.com.au> 0.3.0-05
- Bump release number only

* Mon Jul 18 2005 Charlie Brady <charlieb@e-smith.com>
- [0.3.0-04]
- Be prepared for move of dbs to /home/e-smith/db [SF: 1216546]

* Fri Jul 15 2005 Tony Clayton <apc@e-smith.com>
- [0.3.0-03]
- Fix db/signal-event completion algorithms
- Optimize expand-template completion algorithm

* Tue Feb 24 2004 Tony Clayton <apc@e-smith.com>
- [0.3.0-02]
- Streamline completion algorithms for faster execution

* Tue Feb 24 2004 Tony Clayton <apc@e-smith.com>
- [0.3.0-01]
- Changing version to development stream number - 0.3.0

* Thu Jun 26 2003 Charlie Brady <charlieb@e-smith.com>
- [0.2.0-01]
- Changing version to stable stream number - 0.2.0

* Wed Jul 24 2002 Tony Clayton <apc@e-smith.com>
- [0.1.2-01]
- Imported into CVS, fixed description [tonyc 3819]

* Tue Jun 04 2002 Tony Clayton <tonyc@e-smith.com>
- [0.1.1-01]
- remove %post and %postun sections 

* Tue May 07 2002 Tony Clayton <tonyc@e-smith.com>
- [0.1.0-01]
- initial release.
